    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------
    028     * StandardXYURLGenerator.java
    029     * ---------------------------
    030     * (C) Copyright 2002-2007, by Richard Atkinson and Contributors.
    031     *
    032     * Original Author:  Richard Atkinson;
    033     * Contributors:     David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: StandardXYURLGenerator.java,v 1.6.2.3 2007/02/20 15:36:23 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 05-Aug-2002 : Version 1, contributed by Richard Atkinson;
    040     * 29-Aug-2002 : New constructor and member variables to customise series and
    041     *               item parameter names (RA);
    042     * 09-Oct-2002 : Fixed errors reported by Checkstyle (DG);
    043     * 23-Mar-2003 : Implemented Serializable (DG);
    044     * 01-Mar-2004 : Added equals() method (DG);
    045     * 13-Jan-2005 : Modified for XHTML 1.0 compliance (DG);
    046     * ------------- JFREECHART 1.0.x ---------------------------------------------
    047     * 02-Feb-2007 : Removed author tags from all over JFreeChart sources (DG);
    048     *
    049     */
    050
    051    package org.jfree.chart.urls;
    052
    053    import java.io.Serializable;
    054
    055    import org.jfree.data.xy.XYDataset;
    056    import org.jfree.util.ObjectUtilities;
    057
    058    /**
    059     * A URL generator.
    060     */
    061    public class StandardXYURLGenerator implements XYURLGenerator, Serializable {
    062
    063        /** For serialization. */
    064        private static final long serialVersionUID = -1771624523496595382L;
    065
    066        /** The default prefix. */
    067        public static final String DEFAULT_PREFIX = "index.html";
    068
    069        /** The default series parameter. */
    070        public static final String DEFAULT_SERIES_PARAMETER = "series";
    071
    072        /** The default item parameter. */
    073        public static final String DEFAULT_ITEM_PARAMETER = "item";
    074
    075        /** Prefix to the URL */
    076        private String prefix;
    077
    078        /** Series parameter name to go in each URL */
    079        private String seriesParameterName;
    080
    081        /** Item parameter name to go in each URL */
    082        private String itemParameterName;
    083
    084        /**
    085         * Creates a new default generator.  This constructor is equivalent to
    086         * calling <code>StandardXYURLGenerator("index.html", "series", "item");
    087         * </code>.
    088         */
    089        public StandardXYURLGenerator() {
    090            this(DEFAULT_PREFIX, DEFAULT_SERIES_PARAMETER, DEFAULT_ITEM_PARAMETER);
    091        }
    092
    093        /**
    094         * Creates a new generator with the specified prefix.  This constructor
    095         * is equivalent to calling
    096         * <code>StandardXYURLGenerator(prefix, "series", "item");</code>.
    097         *
    098         * @param prefix  the prefix to the URL (<code>null</code> not permitted).
    099         */
    100        public StandardXYURLGenerator(String prefix) {
    101            this(prefix, DEFAULT_SERIES_PARAMETER, DEFAULT_ITEM_PARAMETER);
    102        }
    103
    104        /**
    105         * Constructor that overrides all the defaults
    106         *
    107         * @param prefix  the prefix to the URL (<code>null</code> not permitted).
    108         * @param seriesParameterName  the name of the series parameter to go in
    109         *                             each URL (<code>null</code> not permitted).
    110         * @param itemParameterName  the name of the item parameter to go in each
    111         *                           URL (<code>null</code> not permitted).
    112         */
    113        public StandardXYURLGenerator(String prefix,
    114                                      String seriesParameterName,
    115                                      String itemParameterName) {
    116            if (prefix == null) {
    117                throw new IllegalArgumentException("Null 'prefix' argument.");
    118            }
    119            if (seriesParameterName == null) {
    120                throw new IllegalArgumentException(
    121                        "Null 'seriesParameterName' argument.");
    122            }
    123            if (itemParameterName == null) {
    124                throw new IllegalArgumentException(
    125                        "Null 'itemParameterName' argument.");
    126            }
    127            this.prefix = prefix;
    128            this.seriesParameterName = seriesParameterName;
    129            this.itemParameterName = itemParameterName;
    130        }
    131
    132        /**
    133         * Generates a URL for a particular item within a series.
    134         *
    135         * @param dataset  the dataset.
    136         * @param series  the series number (zero-based index).
    137         * @param item  the item number (zero-based index).
    138         *
    139         * @return The generated URL.
    140         */
    141        public String generateURL(XYDataset dataset, int series, int item) {
    142            String url = this.prefix;
    143            boolean firstParameter = url.indexOf("?") == -1;
    144            url += firstParameter ? "?" : "&amp;";
    145            url += this.seriesParameterName + "=" + series
    146                    + "&amp;" + this.itemParameterName + "=" + item;
    147            return url;
    148        }
    149
    150        /**
    151         * Tests this generator for equality with an arbitrary object.
    152         *
    153         * @param obj  the object (<code>null</code> permitted).
    154         *
    155         * @return A boolean.
    156         */
    157        public boolean equals(Object obj) {
    158            if (obj == this) {
    159                return true;
    160            }
    161            if (!(obj instanceof StandardXYURLGenerator)) {
    162                return false;
    163            }
    164            StandardXYURLGenerator that = (StandardXYURLGenerator) obj;
    165            if (!ObjectUtilities.equal(that.prefix, this.prefix)) {
    166                return false;
    167            }
    168            if (!ObjectUtilities.equal(that.seriesParameterName,
    169                    this.seriesParameterName)) {
    170                return false;
    171            }
    172            if (!ObjectUtilities.equal(that.itemParameterName,
    173                    this.itemParameterName)) {
    174                return false;
    175            }
    176            return true;
    177        }
    178
    179    }